
#include <stdio.h>
#include <stdlib.h>

#include "f2c.h"

/* Table of constant values */
static int k = 11;

int main(void)
{
    /* System generated locals */
    int i__1, i__2, i__3;

    /* Builtin functions */
    double cos(double), sin(double);

    /* Local variables */
    extern int f_c();
    static double h__;
    static int j, l, m;
    static double p[65], q, s[77], u[22] /* was [2][11] */, x, au[26]
	    /* was [2][13] */, xk;
    static int nx;
    static double xp, yp[2], yt[2], yx[2];
    static int kp1, kp2;
    static double xj0[11], ajk[24]  /* was [2][12] */, alp[11], zfi[28]
	    /* was [2][14] */, hd4i[12];
    extern int de44d_c( );
    static double rabc[11], cmar[121]	/* was [11][11] */, ajkp[24]
	    /* was [2][12] */, alpn[11], dely[2];
    static int imax, iniapr, jstart;

    m = 2;
    q = .5;
    x = 0.f;
    yx[0] = cos(q) + 1.;
    yx[1] = -sin(q) + 1.;
    h__ = 1.;
    xk = x + h__;
    yt[0] = cos(q * (xk * 2. - 1.)) + 1.;
    yt[1] = sin(q * (xk * 2. - 1.)) + 1.;
    imax = 16;
    jstart = 0;
    iniapr = 1;
    de44d_c((U_fp)f_c, &m, &k, &iniapr, &imax, &jstart, yx, &x, xj0, au,
             ajk, &h__, hd4i, rabc, alp, alpn, cmar, p, s, &xp, yp, ajkp, u,
             zfi);
    dely[0] = yt[0] - yx[0];
    dely[1] = yt[1] - yx[1];

    printf("\n xp = %21.14e x = %21.14e\n", xp, x);

    printf("\n h__=%21.14e k=%3i iniapr= %1i imax=%3i jstart=%3i\n",h__, k,iniapr,imax,jstart);

    printf("\n yx[0]= %21.14e yx[1]= %21.14e\n", yx[0], yx[1]);
    printf("\n yt[0]= %21.14e yt[1]= %21.14e\n", yt[0], yt[1]);
    printf("\n dely");
    printf("\n %23.14e %23.14e \n", dely[0], dely[1]);

    nx = 1;
    kp2 = 13;
    kp1 = 12;
    printf("\n ---------------------------------------------------\n");
    printf("\n COEFFICIENTS AU AND AJK ON %3i SEGMENT\n", nx);

    i__1 = m;
    for (l = 1; l <= i__1; ++l) {
    printf("\n ---------------------------------------------------");
    printf("\n\n        Chebyshev coefficients for %1i component \n", l );
    printf("\n              for  Y                 for  Y' \n" );

	i__2 = kp1;
	for (j = 1; j <= i__2; ++j) {
	    i__3 = j - 1;
      printf("\n %3i %23.14e %23.14e ", i__3, au[l + (j << 1) - 3], ajk[l + (j << 1) - 3]);
	}
      printf("\n %3i %23.14e ", kp1, au[l + (kp2 << 1) - 3]);
/* L20: */
    printf("\n ");
    }
/* L48: */
/* L50: */
/* L161: */
    return 0;
} /* main */
/*......................................................................*/

 int f_c(double *x, double *y, double *z__, int *m)
{
    /* Builtin functions */
    double cos(double), exp(double), sin(double);

    /* Local variables */
    static double q, r__;

    /* Parameter adjustments */
    --z__;
    --y;

    /* Function Body */
    q = .5;
    r__ = *x * 2. - 1.;
    z__[1] = q * -2. * (y[2] - 1.) + (1. - exp(1. - y[1] + cos(q * r__))) /
            (*x + 1.);
    z__[2] = q * 2. * (y[1] - 1.) + (1. - exp(1. - y[2] + sin(q * r__))) /
            (*x + 1.);
    return 0;
} /* f_c */
